// ALDL_BlueTooth_Reapeater 8192 baud
//
// Mike Waldron 2013
// http://www.xm381.com/xm381/ALDL.html has ALDL info and documentation
//
// This Arduino sketch will recieve, via bluetooth, ALDL requests (8192 baud only) from programs like ALDLdroid or TunerPro
// and transmit the responeses from the ECU back.


// ***** Hardware Config *****

//Status LEDs
#define redled 4
#define greenled 3
#define blueled 2

//HC05 bluetooth transceiver (5, 2, 4, 3) key, state, rx, tx
#define Key 8 
#define RxD 7
#define TxD 6
#define State 5 //PIO11 - reset

#include <SoftwareSerial.h>
SoftwareSerial BluetoothSerial(RxD, TxD); // RX, TX

//ALDL
#define ALDLSerial Serial


// ***** Program Setup *****
void setup() {
  ALDLSerial.begin(8192); 
  BluetoothSerial.begin(9600);
  
// ***** setup BlueTooth *****
   pinMode(State, INPUT);
   pinMode(Key, INPUT);
  
// ***** LEDs *****
  pinMode(redled, OUTPUT);
  pinMode(greenled, OUTPUT);
  pinMode(blueled, OUTPUT);

  LedColor(1);
  delay(1000);

  LedColor(2);
  delay(1000);

  LedColor(3);
  delay(1000);

}

// ***** Main Loop *****
void loop() {

  //paired
  if (digitalRead(State) == HIGH){  

    LedColor(3);

    if (BluetoothSerial.available()) { // retrieve ALDL request data from PC in buffer, if any

      LedColor(1);

      while(BluetoothSerial.available()){ // empty serial buffer
        ALDLSerial.write(BluetoothSerial.read());
      }
    }
  
    if (ALDLSerial.available()) { // retrieve ALDL response data from ECU in buffer, if any

      LedColor(2);

      while(ALDLSerial.available()){ // empty serial buffer
        BluetoothSerial.write (ALDLSerial.read());
      }
    }
  }
  
  //not paired
  else{  
    LedColor(2);
    delay(10);
  }
}

// ***** LED *****
void LedColor(byte color){

  switch (color){

  //Off
  case 0: 
  digitalWrite(redled, LOW);
  digitalWrite(greenled, LOW);
  digitalWrite(blueled, LOW);

  //Red
  case 1:
  digitalWrite(redled, HIGH);
  digitalWrite(greenled, LOW);
  digitalWrite(blueled, LOW);
  return;
  
  //Green
  case 2:
  digitalWrite(redled, LOW);
  digitalWrite(greenled, HIGH);
  digitalWrite(blueled, LOW);
  return;
  
  //Blue
  case 3:
  digitalWrite(redled, LOW);
  digitalWrite(greenled, LOW);
  digitalWrite(blueled, HIGH);
  return;  
  }
}





